import java.awt.Color;

public class Chicken {
  
    private int position = 20;
    private Color color;
    private Circuit c;
    private int number;
  
    int winner = -1;
    
    Chicken(Circuit c, int number, Color color) {
	this.c = c;
	this.number = number;
	this.color = color;
	
	//couleur numero.. par defaut rouge
	c.g.setColor(color);
	//draw chicken number
	c.g.drawString(String.valueOf(number), 5, 20 * (number + 1) + 8);
    }

    public boolean move() throws EndOfRunException, InterruptedException {
	
	if (winner != -1) {
	    throw new EndOfRunException("Exception fin de course",winner);
	}

	int new_position = position + (int) (Math.random() * 2);
	int size = new_position - position;
	
	//Thread.yield();
	Thread.sleep(2);//ralentissement de la course

	//couleur pour le dessin du rectangle
	c.g.setColor(color);
	c.g.fillRect(position, 20 * (number + 1), size, 10);
	position = new_position;
	c.repaint();

	if (position >= Circuit.FINISH_LINE) {
	    c.winRace(number);
	    return true;
	} else {
	    return false;
	}
    }
    
}
